# Go API client for etsi14

OpenAPI definition of ETSI GS QKD 014 Standard.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [OpenAPI-spec](https://www.openapis.org/) from a remote server, you can easily generate an API client.

- API version: 0.0.1
- Package version: 1.0.0
- Generator version: 7.5.0
- Build package: org.openapitools.codegen.languages.GoClientCodegen

## Installation

Install the following dependencies:

```sh
go get github.com/stretchr/testify/assert
go get golang.org/x/net/context
```

Put the package under your project folder and add the following in import:

```go
import etsi14 "code.fbi.h-da.de/danet/quant/etsi014/go/rest/etsi/client"
```

To use a proxy, set the environment variable `HTTP_PROXY`:

```go
os.Setenv("HTTP_PROXY", "http://proxy_name:proxy_port")
```

## Configuration of Server URL

Default configuration comes with `Servers` field that contains server objects as defined in the OpenAPI specification.

### Select Server Configuration

For using other server than the one defined on index 0 set context value `etsi14.ContextServerIndex` of type `int`.

```go
ctx := context.WithValue(context.Background(), etsi14.ContextServerIndex, 1)
```

### Templated Server URL

Templated server URL is formatted using default variables from configuration or from context value `etsi14.ContextServerVariables` of type `map[string]string`.

```go
ctx := context.WithValue(context.Background(), etsi14.ContextServerVariables, map[string]string{
	"basePath": "v2",
})
```

Note, enum values are always validated and all unused variables are silently ignored.

### URLs Configuration per Operation

Each operation can use different server URL defined using `OperationServers` map in the `Configuration`.
An operation is uniquely identified by `"{classname}Service.{nickname}"` string.
Similar rules for overriding default operation server index and variables applies by using `etsi14.ContextOperationServerIndices` and `etsi14.ContextOperationServerVariables` context maps.

```go
ctx := context.WithValue(context.Background(), etsi14.ContextOperationServerIndices, map[string]int{
	"{classname}Service.{nickname}": 2,
})
ctx = context.WithValue(context.Background(), etsi14.ContextOperationServerVariables, map[string]map[string]string{
	"{classname}Service.{nickname}": {
		"port": "8443",
	},
})
```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultAPI* | [**GetKey**](docs/DefaultAPI.md#getkey) | **Get** /api/v1/keys/{slave_SAE_ID}/enc_keys | TBD
*DefaultAPI* | [**GetKeyPost**](docs/DefaultAPI.md#getkeypost) | **Post** /api/v1/keys/{slave_SAE_ID}/enc_keys | 
*DefaultAPI* | [**GetKeyWithIds**](docs/DefaultAPI.md#getkeywithids) | **Get** /api/v1/keys/{master_SAE_ID}/dec_keys | TBD
*DefaultAPI* | [**GetKeyWithIdsPost**](docs/DefaultAPI.md#getkeywithidspost) | **Post** /api/v1/keys/{master_SAE_ID}/dec_keys | TBD
*DefaultAPI* | [**GetStatus**](docs/DefaultAPI.md#getstatus) | **Get** /api/v1/keys/{slave_SAE_ID}/status | TBD


## Documentation For Models

 - [ErrorFormat](docs/ErrorFormat.md)
 - [KeyContainer](docs/KeyContainer.md)
 - [KeyContainerKeysInner](docs/KeyContainerKeysInner.md)
 - [KeyIDsRequest](docs/KeyIDsRequest.md)
 - [KeyIDsRequestKeyIDsInner](docs/KeyIDsRequestKeyIDsInner.md)
 - [KeyRequest](docs/KeyRequest.md)
 - [Status](docs/Status.md)


## Documentation For Authorization

Endpoints do not require authorization.


## Documentation for Utility Methods

Due to the fact that model structure members are all pointers, this package contains
a number of utility functions to easily obtain pointers to values of basic types.
Each of these functions takes a value of the given basic type and returns a pointer to it:

* `PtrBool`
* `PtrInt`
* `PtrInt32`
* `PtrInt64`
* `PtrFloat`
* `PtrFloat32`
* `PtrFloat64`
* `PtrString`
* `PtrTime`

## Author



