# \DefaultAPI

All URIs are relative to *http://localhost*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetKey**](DefaultAPI.md#GetKey) | **Get** /api/v1/keys/{slave_SAE_ID}/enc_keys | TBD
[**GetKeyPost**](DefaultAPI.md#GetKeyPost) | **Post** /api/v1/keys/{slave_SAE_ID}/enc_keys | 
[**GetKeyWithIds**](DefaultAPI.md#GetKeyWithIds) | **Get** /api/v1/keys/{master_SAE_ID}/dec_keys | TBD
[**GetKeyWithIdsPost**](DefaultAPI.md#GetKeyWithIdsPost) | **Post** /api/v1/keys/{master_SAE_ID}/dec_keys | TBD
[**GetStatus**](DefaultAPI.md#GetStatus) | **Get** /api/v1/keys/{slave_SAE_ID}/status | TBD



## GetKey

> KeyContainer GetKey(ctx, slaveSAEID).Number(number).Size(size).Execute()

TBD

### Example

```go
package main

import (
	"context"
	"fmt"
	"os"
	openapiclient "code.fbi.h-da.de/danet/quant/etsi014/go/rest/etsi/client"
)

func main() {
	slaveSAEID := "slaveSAEID_example" // string | SAE ID of the specified slave SAE
	number := int64(789) // int64 |  (optional)
	size := int64(789) // int64 |  (optional)

	configuration := openapiclient.NewConfiguration()
	apiClient := openapiclient.NewAPIClient(configuration)
	resp, r, err := apiClient.DefaultAPI.GetKey(context.Background(), slaveSAEID).Number(number).Size(size).Execute()
	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `DefaultAPI.GetKey``: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}
	// response from `GetKey`: KeyContainer
	fmt.Fprintf(os.Stdout, "Response from `DefaultAPI.GetKey`: %v\n", resp)
}
```

### Path Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
**ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
**slaveSAEID** | **string** | SAE ID of the specified slave SAE | 

### Other Parameters

Other parameters are passed through a pointer to a apiGetKeyRequest struct via the builder pattern


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **number** | **int64** |  | 
 **size** | **int64** |  | 

### Return type

[**KeyContainer**](KeyContainer.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints)
[[Back to Model list]](../README.md#documentation-for-models)
[[Back to README]](../README.md)


## GetKeyPost

> KeyContainer GetKeyPost(ctx, slaveSAEID).KeyRequest(keyRequest).Execute()



### Example

```go
package main

import (
	"context"
	"fmt"
	"os"
	openapiclient "code.fbi.h-da.de/danet/quant/etsi014/go/rest/etsi/client"
)

func main() {
	slaveSAEID := "slaveSAEID_example" // string | SAE ID of the specified slave SAE
	keyRequest := *openapiclient.NewKeyRequest() // KeyRequest | TBD (optional)

	configuration := openapiclient.NewConfiguration()
	apiClient := openapiclient.NewAPIClient(configuration)
	resp, r, err := apiClient.DefaultAPI.GetKeyPost(context.Background(), slaveSAEID).KeyRequest(keyRequest).Execute()
	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `DefaultAPI.GetKeyPost``: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}
	// response from `GetKeyPost`: KeyContainer
	fmt.Fprintf(os.Stdout, "Response from `DefaultAPI.GetKeyPost`: %v\n", resp)
}
```

### Path Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
**ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
**slaveSAEID** | **string** | SAE ID of the specified slave SAE | 

### Other Parameters

Other parameters are passed through a pointer to a apiGetKeyPostRequest struct via the builder pattern


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **keyRequest** | [**KeyRequest**](KeyRequest.md) | TBD | 

### Return type

[**KeyContainer**](KeyContainer.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints)
[[Back to Model list]](../README.md#documentation-for-models)
[[Back to README]](../README.md)


## GetKeyWithIds

> KeyContainer GetKeyWithIds(ctx, masterSAEID).KeyID(keyID).Execute()

TBD

### Example

```go
package main

import (
	"context"
	"fmt"
	"os"
	openapiclient "code.fbi.h-da.de/danet/quant/etsi014/go/rest/etsi/client"
)

func main() {
	masterSAEID := "masterSAEID_example" // string | SAE ID of the calling master SAE
	keyID := "keyID_example" // string |  (optional)

	configuration := openapiclient.NewConfiguration()
	apiClient := openapiclient.NewAPIClient(configuration)
	resp, r, err := apiClient.DefaultAPI.GetKeyWithIds(context.Background(), masterSAEID).KeyID(keyID).Execute()
	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `DefaultAPI.GetKeyWithIds``: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}
	// response from `GetKeyWithIds`: KeyContainer
	fmt.Fprintf(os.Stdout, "Response from `DefaultAPI.GetKeyWithIds`: %v\n", resp)
}
```

### Path Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
**ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
**masterSAEID** | **string** | SAE ID of the calling master SAE | 

### Other Parameters

Other parameters are passed through a pointer to a apiGetKeyWithIdsRequest struct via the builder pattern


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **keyID** | **string** |  | 

### Return type

[**KeyContainer**](KeyContainer.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints)
[[Back to Model list]](../README.md#documentation-for-models)
[[Back to README]](../README.md)


## GetKeyWithIdsPost

> KeyContainer GetKeyWithIdsPost(ctx, masterSAEID).KeyIDsRequest(keyIDsRequest).Execute()

TBD

### Example

```go
package main

import (
	"context"
	"fmt"
	"os"
	openapiclient "code.fbi.h-da.de/danet/quant/etsi014/go/rest/etsi/client"
)

func main() {
	masterSAEID := "masterSAEID_example" // string | SAE ID of the calling master SAE
	keyIDsRequest := *openapiclient.NewKeyIDsRequest() // KeyIDsRequest | TBD (optional)

	configuration := openapiclient.NewConfiguration()
	apiClient := openapiclient.NewAPIClient(configuration)
	resp, r, err := apiClient.DefaultAPI.GetKeyWithIdsPost(context.Background(), masterSAEID).KeyIDsRequest(keyIDsRequest).Execute()
	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `DefaultAPI.GetKeyWithIdsPost``: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}
	// response from `GetKeyWithIdsPost`: KeyContainer
	fmt.Fprintf(os.Stdout, "Response from `DefaultAPI.GetKeyWithIdsPost`: %v\n", resp)
}
```

### Path Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
**ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
**masterSAEID** | **string** | SAE ID of the calling master SAE | 

### Other Parameters

Other parameters are passed through a pointer to a apiGetKeyWithIdsPostRequest struct via the builder pattern


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **keyIDsRequest** | [**KeyIDsRequest**](KeyIDsRequest.md) | TBD | 

### Return type

[**KeyContainer**](KeyContainer.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints)
[[Back to Model list]](../README.md#documentation-for-models)
[[Back to README]](../README.md)


## GetStatus

> Status GetStatus(ctx, slaveSAEID).Execute()

TBD

### Example

```go
package main

import (
	"context"
	"fmt"
	"os"
	openapiclient "code.fbi.h-da.de/danet/quant/etsi014/go/rest/etsi/client"
)

func main() {
	slaveSAEID := "slaveSAEID_example" // string | SAE ID of the specified slave SAE

	configuration := openapiclient.NewConfiguration()
	apiClient := openapiclient.NewAPIClient(configuration)
	resp, r, err := apiClient.DefaultAPI.GetStatus(context.Background(), slaveSAEID).Execute()
	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `DefaultAPI.GetStatus``: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}
	// response from `GetStatus`: Status
	fmt.Fprintf(os.Stdout, "Response from `DefaultAPI.GetStatus`: %v\n", resp)
}
```

### Path Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
**ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
**slaveSAEID** | **string** | SAE ID of the specified slave SAE | 

### Other Parameters

Other parameters are passed through a pointer to a apiGetStatusRequest struct via the builder pattern


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------


### Return type

[**Status**](Status.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints)
[[Back to Model list]](../README.md#documentation-for-models)
[[Back to README]](../README.md)

