/*
ETSI14REST

OpenAPI definition of ETSI GS QKD 014 Standard.

API version: 0.0.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package etsi14

import (
	"encoding/json"
)

// checks if the KeyRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &KeyRequest{}

// KeyRequest struct for KeyRequest
type KeyRequest struct {
	Number *int64 `json:"number,omitempty"`
	Size *int64 `json:"size,omitempty"`
	AdditionalSlaveSAEIDs []string `json:"additional_slave_SAE_IDs,omitempty"`
	ExtensionMandatory []map[string]string `json:"extension_mandatory,omitempty"`
	ExtensionOptional []map[string]string `json:"extension_optional,omitempty"`
}

// NewKeyRequest instantiates a new KeyRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewKeyRequest() *KeyRequest {
	this := KeyRequest{}
	return &this
}

// NewKeyRequestWithDefaults instantiates a new KeyRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewKeyRequestWithDefaults() *KeyRequest {
	this := KeyRequest{}
	return &this
}

// GetNumber returns the Number field value if set, zero value otherwise.
func (o *KeyRequest) GetNumber() int64 {
	if o == nil || IsNil(o.Number) {
		var ret int64
		return ret
	}
	return *o.Number
}

// GetNumberOk returns a tuple with the Number field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KeyRequest) GetNumberOk() (*int64, bool) {
	if o == nil || IsNil(o.Number) {
		return nil, false
	}
	return o.Number, true
}

// HasNumber returns a boolean if a field has been set.
func (o *KeyRequest) HasNumber() bool {
	if o != nil && !IsNil(o.Number) {
		return true
	}

	return false
}

// SetNumber gets a reference to the given int64 and assigns it to the Number field.
func (o *KeyRequest) SetNumber(v int64) {
	o.Number = &v
}

// GetSize returns the Size field value if set, zero value otherwise.
func (o *KeyRequest) GetSize() int64 {
	if o == nil || IsNil(o.Size) {
		var ret int64
		return ret
	}
	return *o.Size
}

// GetSizeOk returns a tuple with the Size field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KeyRequest) GetSizeOk() (*int64, bool) {
	if o == nil || IsNil(o.Size) {
		return nil, false
	}
	return o.Size, true
}

// HasSize returns a boolean if a field has been set.
func (o *KeyRequest) HasSize() bool {
	if o != nil && !IsNil(o.Size) {
		return true
	}

	return false
}

// SetSize gets a reference to the given int64 and assigns it to the Size field.
func (o *KeyRequest) SetSize(v int64) {
	o.Size = &v
}

// GetAdditionalSlaveSAEIDs returns the AdditionalSlaveSAEIDs field value if set, zero value otherwise.
func (o *KeyRequest) GetAdditionalSlaveSAEIDs() []string {
	if o == nil || IsNil(o.AdditionalSlaveSAEIDs) {
		var ret []string
		return ret
	}
	return o.AdditionalSlaveSAEIDs
}

// GetAdditionalSlaveSAEIDsOk returns a tuple with the AdditionalSlaveSAEIDs field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KeyRequest) GetAdditionalSlaveSAEIDsOk() ([]string, bool) {
	if o == nil || IsNil(o.AdditionalSlaveSAEIDs) {
		return nil, false
	}
	return o.AdditionalSlaveSAEIDs, true
}

// HasAdditionalSlaveSAEIDs returns a boolean if a field has been set.
func (o *KeyRequest) HasAdditionalSlaveSAEIDs() bool {
	if o != nil && !IsNil(o.AdditionalSlaveSAEIDs) {
		return true
	}

	return false
}

// SetAdditionalSlaveSAEIDs gets a reference to the given []string and assigns it to the AdditionalSlaveSAEIDs field.
func (o *KeyRequest) SetAdditionalSlaveSAEIDs(v []string) {
	o.AdditionalSlaveSAEIDs = v
}

// GetExtensionMandatory returns the ExtensionMandatory field value if set, zero value otherwise.
func (o *KeyRequest) GetExtensionMandatory() []map[string]string {
	if o == nil || IsNil(o.ExtensionMandatory) {
		var ret []map[string]string
		return ret
	}
	return o.ExtensionMandatory
}

// GetExtensionMandatoryOk returns a tuple with the ExtensionMandatory field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KeyRequest) GetExtensionMandatoryOk() ([]map[string]string, bool) {
	if o == nil || IsNil(o.ExtensionMandatory) {
		return nil, false
	}
	return o.ExtensionMandatory, true
}

// HasExtensionMandatory returns a boolean if a field has been set.
func (o *KeyRequest) HasExtensionMandatory() bool {
	if o != nil && !IsNil(o.ExtensionMandatory) {
		return true
	}

	return false
}

// SetExtensionMandatory gets a reference to the given []map[string]string and assigns it to the ExtensionMandatory field.
func (o *KeyRequest) SetExtensionMandatory(v []map[string]string) {
	o.ExtensionMandatory = v
}

// GetExtensionOptional returns the ExtensionOptional field value if set, zero value otherwise.
func (o *KeyRequest) GetExtensionOptional() []map[string]string {
	if o == nil || IsNil(o.ExtensionOptional) {
		var ret []map[string]string
		return ret
	}
	return o.ExtensionOptional
}

// GetExtensionOptionalOk returns a tuple with the ExtensionOptional field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *KeyRequest) GetExtensionOptionalOk() ([]map[string]string, bool) {
	if o == nil || IsNil(o.ExtensionOptional) {
		return nil, false
	}
	return o.ExtensionOptional, true
}

// HasExtensionOptional returns a boolean if a field has been set.
func (o *KeyRequest) HasExtensionOptional() bool {
	if o != nil && !IsNil(o.ExtensionOptional) {
		return true
	}

	return false
}

// SetExtensionOptional gets a reference to the given []map[string]string and assigns it to the ExtensionOptional field.
func (o *KeyRequest) SetExtensionOptional(v []map[string]string) {
	o.ExtensionOptional = v
}

func (o KeyRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o KeyRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Number) {
		toSerialize["number"] = o.Number
	}
	if !IsNil(o.Size) {
		toSerialize["size"] = o.Size
	}
	if !IsNil(o.AdditionalSlaveSAEIDs) {
		toSerialize["additional_slave_SAE_IDs"] = o.AdditionalSlaveSAEIDs
	}
	if !IsNil(o.ExtensionMandatory) {
		toSerialize["extension_mandatory"] = o.ExtensionMandatory
	}
	if !IsNil(o.ExtensionOptional) {
		toSerialize["extension_optional"] = o.ExtensionOptional
	}
	return toSerialize, nil
}

type NullableKeyRequest struct {
	value *KeyRequest
	isSet bool
}

func (v NullableKeyRequest) Get() *KeyRequest {
	return v.value
}

func (v *NullableKeyRequest) Set(val *KeyRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableKeyRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableKeyRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableKeyRequest(val *KeyRequest) *NullableKeyRequest {
	return &NullableKeyRequest{value: val, isSet: true}
}

func (v NullableKeyRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableKeyRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


