package additions

import "time"

type System interface {
	GetHostname() (string, error)
	SetHostname(hostname *string) error
	GetCurrentTime() time.Time
	GetTimeZoneName() string
	GetTotalMemory() (uint64, error)
	GetFreeMemory() (uint64, error)
	GetUsedMemory() (uint64, error)
	GetDomainName() (string, error)
	GetMotd() (string, error)
	SetMotd(message string) error
	// yang: leaf software-version
	GetSoftwareVersion() (string, error)
}
