package utils

import (
	"fmt"
	"os/exec"
)

type Update struct {
	Path  string
	Value string
	JSON  string
}

func GnmicCommand(address string, args ...string) (string, error) {
	cmd := exec.Command("gnmic", "-a", address, "-u", "admin", "-p", "admin", "--insecure", "-e", "JSON_IETF")
	cmd.Args = append(cmd.Args, args...)
	//command := cmd.String()
	output, err := cmd.Output()
	outputString := string(output)
	if err != nil {
		return outputString, err
	}
	return outputString, nil
}

func BuildKms1RoutingConfig(path, pathID string) []Update {
	return []Update{
		{
			Path: path,
			JSON: fmt.Sprintf(`{"path-id": "%s"}`, pathID),
		},
		{
			Path: fmt.Sprint(path, "/next-hop"),
			JSON: fmt.Sprintf(`{"node-id": "%s"}`, "5e41c291-6121-4335-84f6-41e04b8bdaa2"),
		},
		{
			Path: fmt.Sprint(path, "/next-hop"),
			JSON: fmt.Sprintf(`{"hostname": "%s"}`, "kms_2"),
		},
		{
			Path: fmt.Sprint(path, "/next-hop"),
			JSON: fmt.Sprintf(`{"port": %d}`, 50910),
		},
		{
			Path: fmt.Sprint(path, "/initiating-kms-address"),
			JSON: fmt.Sprintf(`{"node-id": "%s"}`, "5e41c291-6121-4335-84f6-41e04b8bdaa2"),
		},
		{
			Path: fmt.Sprint(path, "/initiating-kms-address"),
			JSON: fmt.Sprintf(`{"hostname": "%s"}`, "kms_2"),
		},
		{
			Path: fmt.Sprint(path, "/initiating-kms-address"),
			JSON: fmt.Sprintf(`{"port": %d}`, 50910),
		},
	}
}

func BuildKms2RoutingConfig(path, pathID string) []Update {
	return []Update{
		{
			Path: path,
			JSON: fmt.Sprintf(`{"path-id": "%s"}`, pathID),
		},
		{
			Path: fmt.Sprint(path, "/prev-hop"),
			JSON: fmt.Sprintf(`{"node-id": "%s"}`, "0ff33c82-7fe1-482b-a0ca-67565806ee4b"),
		},
		{
			Path: fmt.Sprint(path, "/prev-hop"),
			JSON: fmt.Sprintf(`{"hostname": "%s"}`, "kms_1"),
		},
		{
			Path: fmt.Sprint(path, "/prev-hop"),
			JSON: fmt.Sprintf(`{"port": %d}`, 50910),
		},
		{
			Path: fmt.Sprint(path, "/initiating-kms-address"),
			JSON: fmt.Sprintf(`{"node-id": "%s"}`, "0ff33c82-7fe1-482b-a0ca-67565806ee4b"),
		},
		{
			Path: fmt.Sprint(path, "/initiating-kms-address"),
			JSON: fmt.Sprintf(`{"hostname": "%s"}`, "kms_1"),
		},
		{
			Path: fmt.Sprint(path, "/initiating-kms-address"),
			JSON: fmt.Sprintf(`{"port": %d}`, 50910),
		},
	}
}
